
.. index::
   pair: custom-user-model; Michael Herman


.. _django_conseils_start:

==========================================================================================================================
(2019-02-07) **Michael Herman** => **highly recommended** to set up a custom User **when starting a new Django project**
==========================================================================================================================


.. seealso::

   - https://docs.djangoproject.com/en/dev/topics/auth/customizing/#using-a-custom-user-model-when-starting-a-project
   - https://testdriven.io/blog/django-custom-user-model/
   - https://x.com/mikeherman




Advice
=======


It's **highly recommended** to set up a `custom User model`_ when starting a
new Django project.
Without it, you will need to create another model (like UserProfile)
and link it to the Django User model with a OneToOneField if you want
to add new fields to the User model.

.. _`custom User model`:  https://docs.djangoproject.com/en/dev/topics/auth/customizing/#using-a-custom-user-model-when-starting-a-project

managers.py
==============

.. code-block:: python
   :linenos:

    from django.contrib.auth.base_user import BaseUserManager
    from django.utils.translation import ugettext_lazy as _


    class CustomUserManager(BaseUserManager):
        """
        Custom user model manager where email is the unique identifiers
        for authentication instead of usernames.
        """
        def create_user(self, email, password, **extra_fields):
            """
            Create and save a User with the given email and password.
            """
            if not email:
                raise ValueError(_('The Email must be set'))
            email = self.normalize_email(email)
            user = self.model(email=email, **extra_fields)
            user.set_password(password)
            user.save()
            return user

        def create_superuser(self, email, password, **extra_fields):
            """
            Create and save a SuperUser with the given email and password.
            """
            extra_fields.setdefault('is_staff', True)
            extra_fields.setdefault('is_superuser', True)
            extra_fields.setdefault('is_active', True)

            if extra_fields.get('is_staff') is not True:
                raise ValueError(_('Superuser must have is_staff=True.'))
            if extra_fields.get('is_superuser') is not True:
                raise ValueError(_('Superuser must have is_superuser=True.'))
            return self.create_user(email, password, **extra_fields)


models.py
===========


.. code-block:: python
   :linenos:

    from django.db import models
    from django.contrib.auth.models import AbstractUser
    from django.utils.translation import ugettext_lazy as _

    from .managers import CustomUserManager


    class CustomUser(AbstractUser):
        username = None
        email = models.EmailField(_('email address'), unique=True)

        USERNAME_FIELD = 'email'
        REQUIRED_FIELDS = []

        objects = CustomUserManager()

        def __str__(self):
            return self.email
